<?php

# web site to show the status of server/xaseco  process
# it should be useful for server hosters with linux server and more than one tmf server
# this scrip need the log files created by the linux start/stop/restart shell scripts
# it will read it's informations and convert it to this page
# the running xaseco version is displayed too, same with actual releases by Xymph.
# if your version is not uptodate,  the version will be displayed in red color
# the name correspond to the shell script name "SAMPLE"
# state will be displayed as "running", "stopped" and "restarted" in green, red and yellow color
# only the last check will be displayed. depending on the cronjob or manual checking time
# made by nouseforname. thanks to Xymph
#=======================================================================================
#=========================== configure to your needs ====================================== 

# path to log files created by shell scripts,
//$path = "./log/";
#  postfix of the log files
//$postfix = "_status.log";
# your count of servers using status shell
//$servercount = 19;

#=======================================================================================
#============================ don't change below here =====================================
#=======================================================================================
session_start();

	$file = '../../xml/users.xml';
	$xml = simplexml_load_file($file);
	if (!file_exists($file) || $xml->user[0]->Control == 0 || $xml->user[0]->Active == 0 ) {
		if ((!$_SESSION['username']) || ($xml->user[$_SESSION['count']]->Control == 0)) {
			session_destroy();
			header('Location: ../../index.php');
			die;
			}
		}
	$file = '../../xml/servers.xml';
	$servercount = 0;
	$xml = simplexml_load_file($file);
	foreach ($xml->server as $serv) {
		$servercount++;
		}

$path = "./log/";
$postfix = "_status.log";

// take care the log file name and path
$timestamp = time();
$date = date('Y-m-d',$timestamp);
$postfix = "_status.log";
$file = "$path$date$postfix"; 
$count = $servercount * 2;

	// get actual xaseco version, thanks to Xymph :)
	$xaseco_ver = file('http://www.gamers.org/tmn/version.txt');
	foreach ($xaseco_ver as $ver) {
		$newversion = trim($ver);
		}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="X-UA-Compatible" content="IE=EmulateIE7" />
<title>Nouse TMF server control log</title>
<meta name="author" content="Nouseforname"/>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="shortcut icon" href="../../img/favicon.ico" />
<link href="../../css/style.css" rel="stylesheet" media="screen" type="text/css" /> 
<style type="text/css">
<!--
#content {
	background: #bcd;
	width: 600px;	
	border: 2px solid #fff;		
	text-align: center;
	margin: 0px auto;
	padding: 20px 0px 10px 0px ;
	height: auto;
}
table {
	width: 90%;
	border: 1px dotted #fff;
	text-align: center;
	margin: 5px auto ;
	padding: 0px;
}	
th {
	color: #ffffee;
}
.headline {
	background: #555555;
	color: #ffffff;
	font-weight: bold;
}
#toolsheader {
	margin: 0px auto;
	padding: 10px;
}
-->
</style>
</head>
<body>
<div id="toolsheader"><a href="../../index.php" >Back to main control!</a><br /><br />
<a href="../../tools.php?script=Control" >Server control</a></div>
	<div id="content">
		<table cellspacing="1px" cellpadding="1px">
			<tr class="headline" >
				<th colspan="4" >Server Status</th>
			</tr>
			<tr class="headline">
				<td>Name</td><td>App</td><td>State</td><td>Last Check</td>
			</tr>
<?php		
				// check for log file
				if(file_exists($file)) {
					$content = file($file);
								
						// don't read the whole log
						for($i = 0; $i < $count; $i++) {
							// get last check only
							$newcontent = array_reverse($content);
							// seperate each line into single variables
							$entry = explode(" ",$newcontent[$i]); 
								$time = trim($entry[0]);
								$app = trim($entry[1]);
								$version = trim($entry[2]);
								$state = trim($entry[3]);
								// cut last 3 digits from time string
								$last_check = substr($time, 0, 5);
								// make an delete array
								$apps = array(dedi, xaseco, " ");
								$who_ = str_replace($apps, "", $app);
									// dedi or xaseco?
									if (ereg("xaseco", $app))  {
										$tablecolor = "#999992";
										if(ereg("running", $state)) {
											// compare running versions with actual one
											if ( $newversion  == $version ) {
												$tcol = "#fff";
												}
												else {
													$tcol = "#f00";
													}
											$serv = "<td style=\"color: $tcol;\">XAseco v$version</td>";
											}
											else {
												$tcol = "#fff";
												$serv = "<td style=\"color: $tcol;\">XAseco</td>";
												}
										}
									 else {
										$tablecolor = "#afaf99";
										$serv = "<td style=\"color: #116\">Dedi</td>";
										}
							// output			
							echo "\t\t\t<tr bgcolor=\"$tablecolor\">\n";	
							echo "\t\t\t\t<td style=\"font-weight: bold;\">$who_</td>";
							echo $serv;
							if (ereg("running", $state)) {
								$statecol = "#080";
								}
								elseif (ereg("restarted", $state)){
								$statecol = "#ff0";
								}
								else {
									$statecol = "#f00";
									}		
							echo "<td style=\"color: $statecol;\">$state...</td>";
							echo "<td>$last_check h</td>\n";
							echo "\t\t\t</tr>\n";			
					}
				}
				else
				{
					echo"\t\t\t<tr><td>Log file not found!!!</td></tr>\n";
				}
			echo "\t\t</table>\n";
			echo "\t\t<div id=\"link\">
			<a href=\"http://www.gamers.org/tmn\" target=\"_blank\" onfocus=\"this.blur()\" onclick=\"this.blur()\">Get actual XAseco v$newversion !!!</a>\n\t\t</div>";
?>	
	</div>
	<div id="link1" >
	<p>&copy; 2009 by <a href="http://tmf.game-host.org" target="_blank" onfocus="this.blur()" onclick="this.blur()">Nouseforname</a></p>
	</div>
</body>
</html>